package net.mcreator.puzzle_code.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.WidgetSprites;
import net.minecraft.client.gui.components.ImageButton;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.puzzle_code.world.inventory.CustomEffectBlockGUI2Menu;
import net.mcreator.puzzle_code.procedures.ReturnPowerEffectProcedure;
import net.mcreator.puzzle_code.procedures.ReturnDurationEffectTicksProcedure;
import net.mcreator.puzzle_code.procedures.ReturnBlockNameProcedure;
import net.mcreator.puzzle_code.procedures.ParticlesDisplayOffProcedure;
import net.mcreator.puzzle_code.procedures.AmbientDisplayOffProcedure;
import net.mcreator.puzzle_code.network.CustomEffectBlockGUI2ButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class CustomEffectBlockGUI2Screen extends AbstractContainerScreen<CustomEffectBlockGUI2Menu> {
	private final static HashMap<String, Object> guistate = CustomEffectBlockGUI2Menu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	Button button_1;
	Button button_2;
	Button button_3;
	Button button_4;
	ImageButton imagebutton_edit_button;
	ImageButton imagebutton_edit_button1;
	ImageButton imagebutton_on_button;
	ImageButton imagebutton_off_button;
	ImageButton imagebutton_question_mark_button;
	ImageButton imagebutton_on_button1;
	ImageButton imagebutton_off_button1;
	ImageButton imagebutton_question_mark_button1;

	public CustomEffectBlockGUI2Screen(CustomEffectBlockGUI2Menu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 161;
		this.imageHeight = 145;
	}

	private static final ResourceLocation texture = ResourceLocation.parse("puzzle_code:textures/screens/custom_effect_block_gui_2.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics, mouseX, mouseY, partialTicks);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
		if (mouseX > leftPos + 55 && mouseX < leftPos + 75 && mouseY > topPos + 85 && mouseY < topPos + 105)
			guiGraphics.renderTooltip(font, Component.translatable("gui.puzzle_code.custom_effect_block_gui_2.tooltip_nbtambient"), mouseX, mouseY);
		if (mouseX > leftPos + 128 && mouseX < leftPos + 148 && mouseY > topPos + 85 && mouseY < topPos + 105)
			guiGraphics.renderTooltip(font, Component.translatable("gui.puzzle_code.custom_effect_block_gui_2.tooltip_nbtparticles"), mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.custom_effect_block_gui_2.label_power"), 38, 26, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.custom_effect_block_gui_2.label_duration"), 110, 26, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnPowerEffectProcedure.execute(world, x, y, z), 6, 44, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnDurationEffectTicksProcedure.execute(world, x, y, z), 83, 44, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.custom_effect_block_gui_2.label_ambient"), 24, 67, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.custom_effect_block_gui_2.label_particles"), 96, 67, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnBlockNameProcedure.execute(world, x, y, z), 6, 8, -12829636, false);
	}

	@Override
	public void init() {
		super.init();
		button_1 = Button.builder(Component.translatable("gui.puzzle_code.custom_effect_block_gui_2.button_1"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new CustomEffectBlockGUI2ButtonMessage(0, x, y, z));
				CustomEffectBlockGUI2ButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		}).bounds(this.leftPos + 6, this.topPos + 116, 18, 20).build();
		guistate.put("button:button_1", button_1);
		this.addRenderableWidget(button_1);
		button_2 = Button.builder(Component.translatable("gui.puzzle_code.custom_effect_block_gui_2.button_2"), e -> {
		}).bounds(this.leftPos + 51, this.topPos + 116, 18, 20).build();
		guistate.put("button:button_2", button_2);
		this.addRenderableWidget(button_2);
		button_3 = Button.builder(Component.translatable("gui.puzzle_code.custom_effect_block_gui_2.button_3"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new CustomEffectBlockGUI2ButtonMessage(2, x, y, z));
				CustomEffectBlockGUI2ButtonMessage.handleButtonAction(entity, 2, x, y, z);
			}
		}).bounds(this.leftPos + 96, this.topPos + 116, 18, 20).build();
		guistate.put("button:button_3", button_3);
		this.addRenderableWidget(button_3);
		button_4 = Button.builder(Component.translatable("gui.puzzle_code.custom_effect_block_gui_2.button_4"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new CustomEffectBlockGUI2ButtonMessage(3, x, y, z));
				CustomEffectBlockGUI2ButtonMessage.handleButtonAction(entity, 3, x, y, z);
			}
		}).bounds(this.leftPos + 137, this.topPos + 116, 18, 20).build();
		guistate.put("button:button_4", button_4);
		this.addRenderableWidget(button_4);
		imagebutton_edit_button = new ImageButton(this.leftPos + 11, this.topPos + 22, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/settings_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/settings_button_highlight.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new CustomEffectBlockGUI2ButtonMessage(4, x, y, z));
						CustomEffectBlockGUI2ButtonMessage.handleButtonAction(entity, 4, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_edit_button", imagebutton_edit_button);
		this.addRenderableWidget(imagebutton_edit_button);
		imagebutton_edit_button1 = new ImageButton(this.leftPos + 83, this.topPos + 22, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/settings_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/settings_button_highlight.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new CustomEffectBlockGUI2ButtonMessage(5, x, y, z));
						CustomEffectBlockGUI2ButtonMessage.handleButtonAction(entity, 5, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_edit_button1", imagebutton_edit_button1);
		this.addRenderableWidget(imagebutton_edit_button1);
		imagebutton_on_button = new ImageButton(this.leftPos + 10, this.topPos + 85, 40, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/on_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/on_button_highlight.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new CustomEffectBlockGUI2ButtonMessage(6, x, y, z));
						CustomEffectBlockGUI2ButtonMessage.handleButtonAction(entity, 6, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_on_button", imagebutton_on_button);
		this.addRenderableWidget(imagebutton_on_button);
		imagebutton_off_button = new ImageButton(this.leftPos + 10, this.topPos + 85, 40, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/off_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/off_button_highlight.png")), e -> {
					if (AmbientDisplayOffProcedure.execute(world, x, y, z)) {
						PacketDistributor.sendToServer(new CustomEffectBlockGUI2ButtonMessage(7, x, y, z));
						CustomEffectBlockGUI2ButtonMessage.handleButtonAction(entity, 7, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				if (AmbientDisplayOffProcedure.execute(world, x, y, z))
					guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_off_button", imagebutton_off_button);
		this.addRenderableWidget(imagebutton_off_button);
		imagebutton_question_mark_button = new ImageButton(this.leftPos + 55, this.topPos + 85, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/question_mark_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/question_mark_button_highlight.png")), e -> {
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_question_mark_button", imagebutton_question_mark_button);
		this.addRenderableWidget(imagebutton_question_mark_button);
		imagebutton_on_button1 = new ImageButton(this.leftPos + 83, this.topPos + 85, 40, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/on_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/on_button_highlight.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new CustomEffectBlockGUI2ButtonMessage(9, x, y, z));
						CustomEffectBlockGUI2ButtonMessage.handleButtonAction(entity, 9, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_on_button1", imagebutton_on_button1);
		this.addRenderableWidget(imagebutton_on_button1);
		imagebutton_off_button1 = new ImageButton(this.leftPos + 83, this.topPos + 85, 40, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/off_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/off_button_highlight.png")), e -> {
					if (ParticlesDisplayOffProcedure.execute(world, x, y, z)) {
						PacketDistributor.sendToServer(new CustomEffectBlockGUI2ButtonMessage(10, x, y, z));
						CustomEffectBlockGUI2ButtonMessage.handleButtonAction(entity, 10, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				if (ParticlesDisplayOffProcedure.execute(world, x, y, z))
					guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_off_button1", imagebutton_off_button1);
		this.addRenderableWidget(imagebutton_off_button1);
		imagebutton_question_mark_button1 = new ImageButton(this.leftPos + 128, this.topPos + 85, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/question_mark_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/question_mark_button_highlight.png")), e -> {
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_question_mark_button1", imagebutton_question_mark_button1);
		this.addRenderableWidget(imagebutton_question_mark_button1);
	}
}
